### Hierarchy

- AtomWindow
  - AtomAlertWindow

### Implements

- IAtomComponent<IAtomElement>
- INotifyPropertyChanged

## Index

### Constructors

- constructor

### Properties

- app
- commandTemplate
- data
- defaultControlStyle
- disposables
- element
- frameTemplate
- height
- localViewModel
- pendingInits
- title
- titleTemplate
- viewModel
- width
- windowTemplate
- x
- y
- commandTemplate
- frameTemplate
- isControl
- titleTemplate
- windowTemplate

### Accessors

- controlStyle
- parent
- templateParent
- theme
- vsProps

### Methods

- append
- atomParent
- beginEdit
- bind
- bindEvent
- close
- create
- dispose
- hasProperty
- invalidate
- onPropertyChanged
- onUpdateSize
- onUpdateUI
- preCreate
- registerDisposable
- removeAllChildren
- render
- resolve
- runAfterInit
- setElementClass
- setElementValue
- setLocalValue
- setPrimitiveValue
- unbind
- unbindEvent
- updateSize

## Constructors

### constructor

- new AtomAlertWindow(app: App, e?: HTMLElement): AtomAlertWindow

- Inherited from AtomControl.constructor

  Overrides AtomComponent.constructor

  - Defined in src/web/controls/AtomControl.ts:105

  #### Parameters

  - ##### app: App

  - ##### Optional e: HTMLElement

  #### Returns AtomAlertWindow

## Properties

### app

app: App

Implementation of IAtomComponent.app

Inherited from AtomComponent.app

- Defined in src/core/AtomComponent.ts:152

### commandTemplate

commandTemplate: IClassOf<AtomControl>

Inherited from AtomWindow.commandTemplate

- Defined in src/web/controls/AtomWindow.tsx:176

### data

data: any

Implementation of IAtomComponent.data

Inherited from AtomComponent.data

- Defined in src/core/AtomComponent.ts:60

### defaultControlStyle

defaultControlStyle: any

Inherited from AtomControl.defaultControlStyle

- Defined in src/web/controls/AtomControl.ts:46

### disposables

disposables: AtomDisposableList

Inherited from AtomComponent.disposables

- Defined in src/core/AtomComponent.ts:55

### element

element: HTMLElement

Implementation of IAtomComponent.element

Inherited from AtomComponent.element

- Defined in src/core/AtomComponent.ts:57

### frameTemplate

frameTemplate: IClassOf<AtomWindowFrameTemplate> = AtomWindowFrameTemplate

Inherited from AtomWindow.frameTemplate

- Defined in src/web/controls/AtomWindow.tsx:180

### height

height: string = ""

Inherited from AtomWindow.height

- Defined in src/web/controls/AtomWindow.tsx:168

### localViewModel

localViewModel: any

Implementation of IAtomComponent.localViewModel

Inherited from AtomComponent.localViewModel

- Defined in src/core/AtomComponent.ts:66

### Protected pendingInits

pendingInits: Array<function>

Inherited from AtomComponent.pendingInits

- Defined in src/core/AtomComponent.ts:68

### title

title: string = ""

Inherited from AtomWindow.title

- Defined in src/web/controls/AtomWindow.tsx:164

### titleTemplate

titleTemplate: IClassOf<AtomControl> = AtomWindowTitleTemplate

Inherited from AtomWindow.titleTemplate

- Defined in src/web/controls/AtomWindow.tsx:178

### viewModel

viewModel: AtomAlertViewModel

Implementation of IAtomComponent.viewModel

Overrides AtomComponent.viewModel

- Defined in src/web/controls/AtomAlertWindow.tsx:15

### width

width: string = ""

Inherited from AtomWindow.width

- Defined in src/web/controls/AtomWindow.tsx:166

### windowTemplate

windowTemplate: IClassOf<AtomControl>

Inherited from AtomWindow.windowTemplate

- Defined in src/web/controls/AtomWindow.tsx:174

### x

x: number = -1

Inherited from AtomWindow.x

- Defined in src/web/controls/AtomWindow.tsx:170

### y

y: number = -1

Inherited from AtomWindow.y

- Defined in src/web/controls/AtomWindow.tsx:172

### Static commandTemplate

commandTemplate: function = XNode.prepare("commandTemplate", true, true)

Inherited from AtomWindow.commandTemplate

- Defined in src/web/controls/AtomWindow.tsx:154

#### Type declaration

- - (attributes: Partial<T>, ...nodes: XNode[]): XNode

  - #### Parameters

    - ##### attributes: Partial<T>

    - ##### Rest ...nodes: XNode[]

    #### Returns XNode

### Static frameTemplate

frameTemplate: function = XNode.prepare("frameTemplate", true, true)

Inherited from AtomWindow.frameTemplate

- Defined in src/web/controls/AtomWindow.tsx:158

#### Type declaration

- - (attributes: Partial<T>, ...nodes: XNode[]): XNode

  - #### Parameters

    - ##### attributes: Partial<T>

    - ##### Rest ...nodes: XNode[]

    #### Returns XNode

### Static isControl

isControl: true = true

Inherited from AtomComponent.isControl

- Defined in src/core/AtomComponent.ts:52

### Static titleTemplate

titleTemplate: function = XNode.prepare("titleTemplate", true, true)

Inherited from AtomWindow.titleTemplate

- Defined in src/web/controls/AtomWindow.tsx:156

#### Type declaration

- - (attributes: Partial<T>, ...nodes: XNode[]): XNode

  - #### Parameters

    - ##### attributes: Partial<T>

    - ##### Rest ...nodes: XNode[]

    #### Returns XNode

### Static windowTemplate

windowTemplate: function = XNode.prepare("windowTemplate", true, true)

Inherited from AtomWindow.windowTemplate

- Defined in src/web/controls/AtomWindow.tsx:152

#### Type declaration

- - (attributes: Partial<T>, ...nodes: XNode[]): XNode

  - #### Parameters

    - ##### attributes: Partial<T>

    - ##### Rest ...nodes: XNode[]

    #### Returns XNode

## Accessors

### controlStyle

- get controlStyle(): AtomStyle
- set controlStyle(v: AtomStyle): void

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:49

  #### Returns AtomStyle

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:67

  #### Parameters

  - ##### v: AtomStyle

  #### Returns void

### parent

- get parent(): AtomControl

- Inherited from AtomControl.parent

  Overrides AtomComponent.parent

  - Defined in src/web/controls/AtomControl.ts:99

  Gets Parent AtomControl of this control.

  #### Returns AtomControl

### templateParent

- get templateParent(): any

- Inherited from AtomWindow.templateParent

  - Defined in src/web/controls/AtomWindow.tsx:160

  #### Returns any

### theme

- get theme(): AtomStyleSheet
- set theme(v: AtomStyleSheet): void

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:86

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Returns AtomStyleSheet

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:91

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Parameters

  - ##### v: AtomStyleSheet

  #### Returns void

### vsProps

- get vsProps(): object | object | __type

- Inherited from AtomComponent.vsProps

  - Defined in src/core/AtomComponent.ts:138

  Do not ever use, only available as intellisense feature for vs code editor.

  #### Returns object | object | __type

## Methods

### append

- append(element: AtomControl | HTMLElement | Text): AtomControl

- Inherited from AtomControl.append

  Overrides AtomComponent.append

  - Defined in src/web/controls/AtomControl.ts:132

  #### Parameters

  - ##### element: AtomControl | HTMLElement | Text

  #### Returns AtomControl

### atomParent

- atomParent(e: HTMLElement): AtomControl

- Inherited from AtomControl.atomParent

  Overrides AtomComponent.atomParent

  - Defined in src/web/controls/AtomControl.ts:121

  #### Parameters

  - ##### e: HTMLElement

  #### Returns AtomControl

### beginEdit

- beginEdit(): IDisposable

- Inherited from AtomComponent.beginEdit

  - Defined in src/core/AtomComponent.ts:405

  #### Returns IDisposable

### bind

- bind(element: HTMLElement, name: string, path: PathList[], twoWays?: boolean | string[], valueFunc?: function, source?: any): IDisposable

- Inherited from AtomComponent.bind

  - Defined in src/core/AtomComponent.ts:167

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### path: PathList[]

  - ##### Optional twoWays: boolean | string[]

  - ##### Optional valueFunc: function

    - - (...v: any[]): any

      - #### Parameters

        - ##### Rest ...v: any[]

        #### Returns any

  - ##### Optional source: any

  #### Returns IDisposable

### bindEvent

- bindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): IDisposable

- Inherited from AtomComponent.bindEvent

  - Defined in src/core/AtomComponent.ts:205

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns IDisposable

### close

- close(): void

- Inherited from AtomWindow.close

  - Defined in src/web/controls/AtomWindow.tsx:194

  #### Returns void

### Protected create

- create(): void

- Overrides AtomComponent.create

  - Defined in src/web/controls/AtomAlertWindow.tsx:17

  #### Returns void

### dispose

- dispose(e?: HTMLElement): void

- Inherited from AtomComponent.dispose

  - Defined in src/core/AtomComponent.ts:355

  #### Parameters

  - ##### Optional e: HTMLElement

  #### Returns void

### hasProperty

- hasProperty(name: string): boolean

- Implementation of IAtomComponent.hasProperty

  Inherited from AtomComponent.hasProperty

  - Defined in src/core/AtomComponent.ts:273

  Control checks if property is declared on the control or not. Since TypeScript no longer creates enumerable properties, we have to inspect name and PropertyMap which is generated by `@BindableProperty` or the value is not set to undefined.

  #### Parameters

  - ##### name: string

    name of Property

  #### Returns boolean

### invalidate

- invalidate(): void

- Inherited from AtomComponent.invalidate

  - Defined in src/core/AtomComponent.ts:425

  #### Returns void

### onPropertyChanged

- onPropertyChanged(name: string): void

- Implementation of INotifyPropertyChanged.onPropertyChanged

  Inherited from AtomWindow.onPropertyChanged

  Overrides AtomControl.onPropertyChanged

  - Defined in src/web/controls/AtomWindow.tsx:184

  #### Parameters

  - ##### name: string

  #### Returns void

### Protected onUpdateSize

- onUpdateSize(): void

- Inherited from AtomControl.onUpdateSize

  - Defined in src/web/controls/AtomControl.ts:283

  #### Returns void

### onUpdateUI

- onUpdateUI(): void

- Inherited from AtomWindow.onUpdateUI

  Overrides AtomComponent.onUpdateUI

  - Defined in src/web/controls/AtomWindow.tsx:207

  #### Returns void

### Protected preCreate

- preCreate(): void

- Inherited from AtomWindow.preCreate

  Overrides AtomControl.preCreate

  - Defined in src/web/controls/AtomWindow.tsx:262

  #### Returns void

### registerDisposable

- registerDisposable(d: IDisposable): IDisposable

- Inherited from AtomComponent.registerDisposable

  - Defined in src/core/AtomComponent.ts:449

  #### Parameters

  - ##### d: IDisposable

  #### Returns IDisposable

### Protected removeAllChildren

- removeAllChildren(e: HTMLElement): void

- Inherited from AtomControl.removeAllChildren

  - Defined in src/web/controls/AtomControl.ts:287

  #### Parameters

  - ##### e: HTMLElement

  #### Returns void

### Protected render

- render(node: XNode, e?: any, creator?: any): void

- Inherited from AtomComponent.render

  - Defined in src/core/AtomComponent.ts:453

  #### Parameters

  - ##### node: XNode

  - ##### Optional e: any

  - ##### Optional creator: any

  #### Returns void

### Protected resolve

- resolve<TService>(c: TService, selfName?: string | function): IAnyInstanceType<TService>

- Inherited from AtomComponent.resolve

  - Defined in src/core/AtomComponent.ts:544

  #### Type parameters

  - #### TService

  #### Parameters

  - ##### c: TService

  - ##### Optional selfName: string | function

  #### Returns IAnyInstanceType<TService>

### runAfterInit

- runAfterInit(f: function): void

- Inherited from AtomComponent.runAfterInit

  - Defined in src/core/AtomComponent.ts:441

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### Protected setElementClass

- setElementClass(element: HTMLElement, value: any, clear?: boolean): void

- Inherited from AtomControl.setElementClass

  - Defined in src/web/controls/AtomControl.ts:245

  #### Parameters

  - ##### element: HTMLElement

  - ##### value: any

  - ##### Optional clear: boolean

  #### Returns void

### Protected setElementValue

- setElementValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomControl.setElementValue

  Overrides AtomComponent.setElementValue

  - Defined in src/web/controls/AtomControl.ts:158

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setLocalValue

- setLocalValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setLocalValue

  - Defined in src/core/AtomComponent.ts:325

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setPrimitiveValue

- setPrimitiveValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setPrimitiveValue

  - Defined in src/core/AtomComponent.ts:290

  Use this method if you want to set attribute on HTMLElement immediately but defer atom control property

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement

  - ##### name: string

    string

  - ##### value: any

    any

  #### Returns void

### unbind

- unbind(element: HTMLElement, name?: string): void

- Inherited from AtomComponent.unbind

  - Defined in src/core/AtomComponent.ts:197

  Remove all bindings associated with given element and optional name

  #### Parameters

  - ##### element: HTMLElement

    T

  - ##### Optional name: string

    string

  #### Returns void

### unbindEvent

- unbindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): void

- Inherited from AtomComponent.unbindEvent

  - Defined in src/core/AtomComponent.ts:235

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns void

### updateSize

- updateSize(): void

- Inherited from AtomControl.updateSize

  - Defined in src/web/controls/AtomControl.ts:141

  #### Returns void

Generated using TypeDoc